diff --git a/gcc/range-op-float.cc b/gcc/range-op-float.cc
index 2bd3dc9253f..15ba19c2deb 100644
--- a/gcc/range-op-float.cc
+++ b/gcc/range-op-float.cc
@@ -232,7 +232,8 @@ build_le (frange &r, tree type, const frange &val)
 {
   gcc_checking_assert (!val.known_isnan ());
 
-  r.set (type, dconstninf, val.upper_bound ());
+  REAL_VALUE_TYPE ninf = *TREE_REAL_CST_PTR (vrp_val_min (type));
+  r.set (type, ninf, val.upper_bound ());
 
   // Add both zeros if there's the possibility of zero equality.
   frange_add_zeros (r, type);
@@ -257,7 +258,8 @@ build_lt (frange &r, tree type, const frange &val)
       return false;
     }
   // We only support closed intervals.
-  r.set (type, dconstninf, val.upper_bound ());
+  REAL_VALUE_TYPE ninf = *TREE_REAL_CST_PTR (vrp_val_min (type));
+  r.set (type, ninf, val.upper_bound ());
   return true;
 }
 
@@ -268,7 +270,8 @@ build_ge (frange &r, tree type, const frange &val)
 {
   gcc_checking_assert (!val.known_isnan ());
 
-  r.set (type, val.lower_bound (), dconstinf);
+  REAL_VALUE_TYPE inf = *TREE_REAL_CST_PTR (vrp_val_max (type));
+  r.set (type, val.lower_bound (), inf);
 
   // Add both zeros if there's the possibility of zero equality.
   frange_add_zeros (r, type);
@@ -294,7 +297,8 @@ build_gt (frange &r, tree type, const frange &val)
     }
 
   // We only support closed intervals.
-  r.set (type, val.lower_bound (), dconstinf);
+  REAL_VALUE_TYPE inf = *TREE_REAL_CST_PTR (vrp_val_max (type));
+  r.set (type, val.lower_bound (), inf);
   return true;
 }
 
diff --git a/gcc/value-range.cc b/gcc/value-range.cc
index 7e8028eced2..e57d60e1bac 100644
--- a/gcc/value-range.cc
+++ b/gcc/value-range.cc
@@ -338,6 +338,18 @@ frange::set (tree min, tree max, value_range_kind kind)
       m_neg_nan = false;
     }
 
+  // For -ffinite-math-only we can drop ranges outside the
+  // representable numbers to min/max for the type.
+  if (flag_finite_math_only)
+    {
+      REAL_VALUE_TYPE min_repr = *TREE_REAL_CST_PTR (vrp_val_min (m_type));
+      REAL_VALUE_TYPE max_repr = *TREE_REAL_CST_PTR (vrp_val_max (m_type));
+      if (real_less (&m_min, &min_repr))
+	m_min = min_repr;
+      if (real_less (&max_repr, &m_max))
+	m_max = max_repr;
+    }
+
   // Check for swapped ranges.
   gcc_checking_assert (tree_compare (LE_EXPR, min, max));
 
@@ -371,8 +383,8 @@ bool
 frange::normalize_kind ()
 {
   if (m_kind == VR_RANGE
-      && real_isinf (&m_min, 1)
-      && real_isinf (&m_max, 0))
+      && vrp_val_is_min (build_real (m_type, m_min))
+      && vrp_val_is_max (build_real (m_type, m_max)))
     {
       if (m_pos_nan && m_neg_nan)
 	{
@@ -385,8 +397,8 @@ frange::normalize_kind ()
       if (!m_pos_nan || !m_neg_nan)
 	{
 	  m_kind = VR_RANGE;
-	  m_min = dconstninf;
-	  m_max = dconstinf;
+	  m_min = *TREE_REAL_CST_PTR (vrp_val_min (m_type));
+	  m_max = *TREE_REAL_CST_PTR (vrp_val_max (m_type));
 	  return true;
 	}
     }
@@ -706,8 +718,8 @@ frange::verify_range ()
     case VR_VARYING:
       gcc_checking_assert (m_type);
       gcc_checking_assert (m_pos_nan && m_neg_nan);
-      gcc_checking_assert (real_isinf (&m_min, 1));
-      gcc_checking_assert (real_isinf (&m_max, 0));
+      gcc_checking_assert (vrp_val_is_min (build_real (m_type, m_min)));
+      gcc_checking_assert (vrp_val_is_max (build_real (m_type, m_max)));
       return;
     case VR_RANGE:
       gcc_checking_assert (m_type);
@@ -732,7 +744,8 @@ frange::verify_range ()
   // If all the properties are clear, we better not span the entire
   // domain, because that would make us varying.
   if (m_pos_nan && m_neg_nan)
-    gcc_checking_assert (!real_isinf (&m_min, 1) || !real_isinf (&m_max, 0));
+    gcc_checking_assert (!vrp_val_is_min (build_real (m_type, m_min))
+			 || !vrp_val_is_max (build_real (m_type, m_max)));
 }
 
 // We can't do much with nonzeros yet.
@@ -779,7 +792,7 @@ frange::zero_p () const
 void
 frange::set_nonnegative (tree type)
 {
-  set (type, dconst0, dconstinf);
+  set (type, dconst0, *TREE_REAL_CST_PTR (vrp_val_max (type)));
 
   // Set +NAN as the only possibility.
   if (HONOR_NANS (type))
@@ -3886,23 +3899,6 @@ range_tests_floats ()
   r0.clear_nan ();
   ASSERT_FALSE (r0.varying_p ());
 
-  // The endpoints of a VARYING are +-INF.
-  r0.set_varying (float_type_node);
-  ASSERT_TRUE (real_identical (&r0.lower_bound (), &dconstninf));
-  ASSERT_TRUE (real_identical (&r0.upper_bound (), &dconstinf));
-
-  // The maximum representable range for a type is still a subset of VARYING.
-  REAL_VALUE_TYPE q, r;
-  real_min_representable (&q, float_type_node);
-  real_max_representable (&r, float_type_node);
-  r0 = frange (float_type_node, q, r);
-  // r0 is not a varying, because it does not include -INF/+INF.
-  ASSERT_FALSE (r0.varying_p ());
-  // The upper bound of r0 must be less than +INF.
-  ASSERT_TRUE (real_less (&r0.upper_bound (), &dconstinf));
-  // The lower bound of r0 must be greater than -INF.
-  ASSERT_TRUE (real_less (&dconstninf, &r0.lower_bound ()));
-
   // For most architectures, where float and double are different
   // sizes, having the same endpoints does not necessarily mean the
   // ranges are equal.
diff --git a/gcc/value-range.h b/gcc/value-range.h
index 3668b331187..74879b76b40 100644
--- a/gcc/value-range.h
+++ b/gcc/value-range.h
@@ -593,6 +593,8 @@ extern void dump_value_range (FILE *, const vrange *);
 extern bool vrp_val_is_min (const_tree);
 extern bool vrp_val_is_max (const_tree);
 extern bool vrp_operand_equal_p (const_tree, const_tree);
+inline void real_max_representable (REAL_VALUE_TYPE *r, const_tree type);
+inline void real_min_representable (REAL_VALUE_TYPE *r, const_tree type);
 
 inline value_range_kind
 vrange::kind () const
@@ -1009,7 +1011,15 @@ vrp_val_max (const_tree type)
       return wide_int_to_tree (const_cast<tree> (type), max);
     }
   if (frange::supports_p (type))
-    return build_real (const_cast <tree> (type), dconstinf);
+    {
+      if (flag_finite_math_only)
+	{
+	  REAL_VALUE_TYPE r;
+	  real_max_representable (&r, type);
+	  return build_real (const_cast <tree> (type), r);
+	}
+      return build_real (const_cast <tree> (type), dconstinf);
+    }
   return NULL_TREE;
 }
 
@@ -1023,7 +1033,15 @@ vrp_val_min (const_tree type)
   if (POINTER_TYPE_P (type))
     return build_zero_cst (const_cast<tree> (type));
   if (frange::supports_p (type))
-    return build_real (const_cast <tree> (type), dconstninf);
+    {
+      if (flag_finite_math_only)
+	{
+	  REAL_VALUE_TYPE r;
+	  real_min_representable (&r, type);
+	  return build_real (const_cast <tree> (type), r);
+	}
+      return build_real (const_cast <tree> (type), dconstninf);
+    }
   return NULL_TREE;
 }
 
@@ -1073,8 +1091,8 @@ frange::set_varying (tree type)
 {
   m_kind = VR_VARYING;
   m_type = type;
-  m_min = dconstninf;
-  m_max = dconstinf;
+  m_min = *TREE_REAL_CST_PTR (vrp_val_min (type));
+  m_max = *TREE_REAL_CST_PTR (vrp_val_max (type));
   m_pos_nan = true;
   m_neg_nan = true;
 }
@@ -1133,7 +1151,7 @@ frange::clear_nan ()
 // Set R to maximum representable value for TYPE.
 
 inline void
-real_max_representable (REAL_VALUE_TYPE *r, tree type)
+real_max_representable (REAL_VALUE_TYPE *r, const_tree type)
 {
   char buf[128];
   get_max_float (REAL_MODE_FORMAT (TYPE_MODE (type)),
@@ -1145,7 +1163,7 @@ real_max_representable (REAL_VALUE_TYPE *r, tree type)
 // Set R to minimum representable value for TYPE.
 
 inline void
-real_min_representable (REAL_VALUE_TYPE *r, tree type)
+real_min_representable (REAL_VALUE_TYPE *r, const_tree type)
 {
   real_max_representable (r, type);
   *r = real_value_negate (r);